#ifndef PCH_HEADER
#define PCH_HEADER

#define _CRT_RAND_S


#include <math.h>
#include <string.h>
#include <stdlib.h>

#include <iostream>
#include <strstream>
#include <fstream>


#include <stdio.h>
#include <limits.h>
#include <time.h>

inline double sqr(double a) {double x = a;return x * x;};
inline float sqr(float a) {float x = a;return x * x;};

//	A few simple extensions to the string class to make parsing easier
class mystring : public std::string
{
public:
	//	Checks to see if a line starts with a specific string
	//
	bool startsWith(const char * str) const
	{
		return (strncmp(c_str(),str,strlen(str)) == 0);
	};
	bool startsWith(const char * str,const char *& p) const
	{
		if (startsWith(str))
		{
			p = c_str()+strlen(str);
			return true;
		}
		else
		{
			p = 0;
			return false;
		}
	};
	//	Returns a pointer to part way along the string which can be used convert numbers at specific positions to values
	const char * operator +(int i){return (c_str()+i);};
	//	A cast to return the underlying const char * pointer
	operator const char * () const {return (c_str());};
	//	An explicit [] operator, otherwise it cant work out whether it should use the string[] or the const char * operator
	//	even though they would both return the same thing!
	char operator [](int i) const {return std::string::operator [](i);};
};


#ifdef _WIN32
#include <direct.h>
#define GetCurrentDir _getcwd
#define MakeDir _mkdir
#define MKDIR(a) mkdir(a)
#else
#include "sys/stat.h"
#include <unistd.h>    
#define GetCurrentDir getcwd 
#define MKDIR(a) mkdir(a,S_IRWXU)
#define MakeDir(x) mkdir(x,0777)
#endif

#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>


extern "C"
{
	#include "StringLib.h"
	#include "SequenceLib.h"
	#include "GenomeLib.h"
	#include "MatrixLib.h"
	#include "AffyLib.h"
}


#ifdef _WIN32
#define FILE_SEP '\\'
#else
#define FILE_SEP '/'
#endif

using namespace std;

#endif