#pragma once

#define MAX_LINE 5000

typedef map<string,size_t> fastaMap;

void trimR(char * buffer);

class fastaFile 
{
public:
	enum 
	{
		FORWARD = true,
		REVERSE = false
	};
private:
	int max_chromosome;
	bool readName();

protected:
    ifstream f;
	char m_name[MAX_LINE];
	char m_sequence[MAX_LINE];
public:
	fastaFile();
	~fastaFile();

	bool open(const char * filename);
	bool readEntry();
	bool readEntry(string & sequence,bool minLoad = false);

};
